Index: NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lib_mpp.F90
===================================================================
--- NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lib_mpp.F90	(revision 14349)
+++ NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/lib_mpp.F90	(revision 14363)
@@ -139,5 +139,8 @@
 
    ! Neighbourgs informations
-   INTEGER, DIMENSION(8), PUBLIC ::   mpinei     !: 8-neighbourg MPI indexes (starting at 0, -1 if no neighbourg)
+   INTEGER,    PARAMETER, PUBLIC ::   n_hlsmax = 3
+   INTEGER, DIMENSION(         8), PUBLIC ::   mpinei      !: 8-neighbourg MPI indexes (starting at 0, -1 if no neighbourg)
+   INTEGER, DIMENSION(n_hlsmax,8), PUBLIC ::   mpiSnei     !: 8-neighbourg Send MPI indexes (starting at 0, -1 if no neighbourg)
+   INTEGER, DIMENSION(n_hlsmax,8), PUBLIC ::   mpiRnei     !: 8-neighbourg Recv MPI indexes (starting at 0, -1 if no neighbourg)
    INTEGER,    PARAMETER, PUBLIC ::   jpwe = 1   !: WEst
    INTEGER,    PARAMETER, PUBLIC ::   jpea = 2   !: EAst
@@ -160,6 +163,6 @@
 
    ! variables used for MPI3 neighbourhood collectives
-   INTEGER, PUBLIC ::   mpi_nc_com4       ! MPI3 neighbourhood collectives communicator
-   INTEGER, PUBLIC ::   mpi_nc_com8       ! MPI3 neighbourhood collectives communicator (with diagionals)
+   INTEGER, DIMENSION(n_hlsmax), PUBLIC ::   mpi_nc_com4       ! MPI3 neighbourhood collectives communicator
+   INTEGER, DIMENSION(n_hlsmax), PUBLIC ::   mpi_nc_com8       ! MPI3 neighbourhood collectives communicator (with diagionals)
 
    ! North fold condition in mpp_mpi with jpni > 1 (PUBLIC for TAM)
@@ -1100,5 +1103,5 @@
 
    
-   SUBROUTINE mpp_ini_nc
+   SUBROUTINE mpp_ini_nc( khls )
       !!----------------------------------------------------------------------
       !!               ***  routine mpp_ini_nc  ***
@@ -1114,25 +1117,31 @@
       !!         mpi_nc_com8 = MPI3 neighbourhood collectives communicator (with diagonals)
       !!----------------------------------------------------------------------
-      INTEGER, DIMENSION(:), ALLOCATABLE :: inei4, inei8
-      INTEGER :: icnt4, icnt8
-      INTEGER :: ierr
-      LOGICAL, PARAMETER :: ireord = .FALSE.
+      INTEGER,             INTENT(in   ) ::   khls        ! halo size, default = nn_hls
+      !
+      INTEGER, DIMENSION(:), ALLOCATABLE :: iSnei4, iRnei4, iSnei8, iRnei8
+      INTEGER                            :: iScnt4, iRcnt4, iScnt8, iRcnt8
+      INTEGER                            :: ierr
+      LOGICAL, PARAMETER                 :: ireord = .FALSE.
       !!----------------------------------------------------------------------
 #if ! defined key_mpi_off && ! defined key_mpi2
       
-      icnt4 = COUNT( mpinei(1:4) >= 0 )
-      icnt8 = COUNT( mpinei(1:8) >= 0 )
-
-      ALLOCATE( inei4(icnt4), inei8(icnt8) )   ! ok if icnt4 or icnt8 = 0
-
-      inei4 = PACK( mpinei(1:4), mask = mpinei(1:4) >= 0 )
-      inei8 = PACK( mpinei(1:8), mask = mpinei(1:8) >= 0 )
-
-      CALL MPI_Dist_graph_create_adjacent(mpi_comm_oce, icnt4, inei4, MPI_UNWEIGHTED,   &
-         &                                              icnt4, inei4, MPI_UNWEIGHTED, MPI_INFO_NULL, ireord, mpi_nc_com4, ierr)
-      CALL MPI_Dist_graph_create_adjacent(mpi_comm_oce, icnt8, inei8, MPI_UNWEIGHTED,   &
-         &                                              icnt8, inei8, MPI_UNWEIGHTED, MPI_INFO_NULL, ireord, mpi_nc_com8, ierr)
-
-      DEALLOCATE (inei4, inei8)
+      iScnt4 = COUNT( mpiSnei(khls,1:4) >= 0 )
+      iRcnt4 = COUNT( mpiRnei(khls,1:4) >= 0 )
+      iScnt8 = COUNT( mpiSnei(khls,1:8) >= 0 )
+      iRcnt8 = COUNT( mpiRnei(khls,1:8) >= 0 )
+
+      ALLOCATE( iSnei4(iScnt4), iRnei4(iRcnt4), iSnei8(iScnt8), iRnei8(iRcnt8) )   ! ok if icnt4 or icnt8 = 0
+
+      iSnei4 = PACK( mpiSnei(khls,1:4), mask = mpiSnei(khls,1:4) >= 0 )
+      iRnei4 = PACK( mpiRnei(khls,1:4), mask = mpiRnei(khls,1:4) >= 0 )
+      iSnei8 = PACK( mpiSnei(khls,1:8), mask = mpiSnei(khls,1:8) >= 0 )
+      iRnei8 = PACK( mpiRnei(khls,1:8), mask = mpiRnei(khls,1:8) >= 0 )
+
+      CALL MPI_Dist_graph_create_adjacent( mpi_comm_oce, iScnt4, iSnei4, MPI_UNWEIGHTED, iRcnt4, iRnei4, MPI_UNWEIGHTED,   &
+         &                                 MPI_INFO_NULL, ireord, mpi_nc_com4(khls), ierr )
+      CALL MPI_Dist_graph_create_adjacent( mpi_comm_oce, iScnt8, iSnei8, MPI_UNWEIGHTED, iRcnt8, iRnei8, MPI_UNWEIGHTED,   &
+         &                                 MPI_INFO_NULL, ireord, mpi_nc_com8(khls), ierr)
+
+      DEALLOCATE( iSnei4, iRnei4, iSnei8, iRnei8 )
 #endif
    END SUBROUTINE mpp_ini_nc
Index: NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/mpp_nfd_generic.h90
===================================================================
--- NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/mpp_nfd_generic.h90	(revision 14349)
+++ NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/mpp_nfd_generic.h90	(revision 14363)
@@ -1,4 +1,4 @@
 
-   SUBROUTINE mpp_nfd_/**/PRECISION( ptab, cd_nat, psgn, kfillmode, pfillval, kfld )
+   SUBROUTINE mpp_nfd_/**/PRECISION( ptab, cd_nat, psgn, kfillmode, pfillval, khls, kfld )
       TYPE(PTR_4d_/**/PRECISION),  DIMENSION(:), INTENT(inout) ::   ptab        ! pointer of arrays on which apply the b.c.
       CHARACTER(len=1), DIMENSION(:), INTENT(in   ) ::   cd_nat      ! nature of array grid-points
@@ -6,4 +6,5 @@
       INTEGER                       , INTENT(in   ) ::   kfillmode   ! filling method for halo over land 
       REAL(PRECISION)               , INTENT(in   ) ::   pfillval    ! background value (used at closed boundaries)
+      INTEGER                       , INTENT(in   ) ::   khls        ! halo size, default = nn_hls
       INTEGER                       , INTENT(in   ) ::   kfld        ! number of pt3d arrays
       !
@@ -64,8 +65,8 @@
          IF( ll_add_line ) THEN
             DO jf = 1, ipf                      ! Loop over the number of arrays to be processed
-               ipj_s(jf) = nn_hls + COUNT( (/ c_NFtype == 'T' .OR. cd_nat(jf) == 'V' .OR. cd_nat(jf) == 'F' /) ) 
+               ipj_s(jf) = khls + COUNT( (/ c_NFtype == 'T' .OR. cd_nat(jf) == 'V' .OR. cd_nat(jf) == 'F' /) ) 
             END DO
          ELSE
-            ipj_s(:) = nn_hls
+            ipj_s(:) = khls
          ENDIF
          
@@ -94,5 +95,5 @@
                ij1 = ij1 + 1
                jj_b(jj,jf) = ij1
-               jj_s(jj,jf) = jpj - 2*nn_hls + jj - i012
+               jj_s(jj,jf) = jpj - 2*khls + jj - i012
             END DO
             !
@@ -137,9 +138,9 @@
             ipi   = nfjpi (ipni)
             !
-            IF( ipni ==   1  ) THEN   ;   iis0 =   1            ! domain  left side: as e-w comm already done -> from 1st column
-            ELSE                      ;   iis0 =   1 + nn_hls   ! default: -> from inner domain 
-            ENDIF
-            IF( ipni == jpni ) THEN   ;   iie0 = ipi            ! domain right side: as e-w comm already done -> until last column
-            ELSE                      ;   iie0 = ipi - nn_hls   ! default: -> until inner domain 
+            IF( ipni ==   1  ) THEN   ;   iis0 =   1          ! domain  left side: as e-w comm already done -> from 1st column
+            ELSE                      ;   iis0 =   1 + khls   ! default: -> from inner domain 
+            ENDIF
+            IF( ipni == jpni ) THEN   ;   iie0 = ipi          ! domain right side: as e-w comm already done -> until last column
+            ELSE                      ;   iie0 = ipi - khls   ! default: -> until inner domain 
             ENDIF
             impp = nfimpp(ipni) - nfimpp(isendto(1))
@@ -205,5 +206,5 @@
             ij1 = jj_b(       1 ,jf)
             ij2 = jj_b(ipj_s(jf),jf)
-            CALL lbc_nfd_nogather( ptab(jf)%pt4d(:,:,:,:), ztabr(:,ij1:ij2,:,:), cd_nat(jf), psgn(jf) )
+            CALL lbc_nfd_nogather( ptab(jf)%pt4d(:,:,:,:), ztabr(:,ij1:ij2,:,:), cd_nat(jf), psgn(jf), khls )
          END DO
          !
@@ -221,9 +222,9 @@
          !
          ! how many lines do we exchange at max? -> ipj    (no further optimizations in this case...)
-         ipj =      nn_hls + 2
+         ipj =      khls + 2
          ! how many lines do we     need at max? -> ipj2   (no further optimizations in this case...)
-         ipj2 = 2 * nn_hls + 2
-         !
-         i0max = jpimax - 2 * nn_hls
+         ipj2 = 2 * khls + 2
+         !
+         i0max = jpimax - 2 * khls
          ibuffsize = i0max * ipj * ipk * ipl * ipf
          ALLOCATE( znorthloc(i0max,ipj,ipk,ipl,ipf), znorthglo(i0max,ipj,ipk,ipl,ipf,ndim_rank_north) )
@@ -255,10 +256,10 @@
          END DO
          !
-         ! need to fill only the first ipj lines of ztabglo as lbc_nfd don't use the last nn_hls lines
+         ! need to fill only the first ipj lines of ztabglo as lbc_nfd don't use the last khls lines
          ijnr = 0
          DO jr = 1, jpni                                                        ! recover the global north array
             iproc = nfproc(jr)
             impp  = nfimpp(jr)
-            ipi   = nfjpi( jr) - 2 * nn_hls                       ! corresponds to Ni_0 but for subdomain iproc
+            ipi   = nfjpi( jr) - 2 * khls                       ! corresponds to Ni_0 but for subdomain iproc
             IF( iproc == -1 ) THEN   ! No neighbour (land proc that was suppressed)
               !
@@ -270,5 +271,5 @@
                         ij2 = jpj - ipj2 + jj                    ! the first ipj lines of the last ipj2 lines
                         DO ji = 1, ipi
-                           ii1 = impp + nn_hls + ji - 1          ! corresponds to mig(nn_hls + ji) but for subdomain iproc
+                           ii1 = impp + khls + ji - 1            ! corresponds to mig(khls + ji) but for subdomain iproc
                            ztabglo(jf)%pt4d(ii1,jj,jk,jl) = ptab(jf)%pt4d(Nis0,ij2,jk,jl) ! chose to take the 1st inner domain point
                         END DO
@@ -279,5 +280,5 @@
                      DO jj = 1, ipj
                         DO ji = 1, ipi
-                           ii1 = impp + nn_hls + ji - 1          ! corresponds to mig(nn_hls + ji) but for subdomain iproc
+                           ii1 = impp + khls + ji - 1            ! corresponds to mig(khls + ji) but for subdomain iproc
                            ztabglo(jf)%pt4d(ii1,jj,jk,jl) = pfillval
                         END DO
@@ -291,5 +292,5 @@
                   DO jj = 1, ipj
                      DO ji = 1, ipi
-                        ii1 = impp + nn_hls + ji - 1             ! corresponds to mig(nn_hls + ji) but for subdomain iproc
+                        ii1 = impp + khls + ji - 1               ! corresponds to mig(khls + ji) but for subdomain iproc
                         ztabglo(jf)%pt4d(ii1,jj,jk,jl) = znorthglo(ji,jj,jk,jl,jf,ijnr)
                      END DO
@@ -302,10 +303,10 @@
          !
          DO jf = 1, ipf
-            CALL lbc_nfd( ztabglo(jf:jf), cd_nat(jf:jf), psgn(jf:jf), 1 )   ! North fold boundary condition
+            CALL lbc_nfd( ztabglo(jf:jf), cd_nat(jf:jf), psgn(jf:jf), khls, 1 )   ! North fold boundary condition
             DO jl = 1, ipl   ;   DO jk = 1, ipk                  ! e-w periodicity
-               DO jj = 1, nn_hls + 1
-                  ij1 = ipj2 - (nn_hls + 1) + jj                 ! need only the last nn_hls + 1 lines until ipj2
-                  ztabglo(jf)%pt4d(              1:nn_hls,ij1,jk,jl) = ztabglo(jf)%pt4d(jpiglo-2*nn_hls+1:jpiglo-nn_hls,ij1,jk,jl)
-                  ztabglo(jf)%pt4d(jpiglo-nn_hls+1:jpiglo,ij1,jk,jl) = ztabglo(jf)%pt4d(         nn_hls+1:     2*nn_hls,ij1,jk,jl)
+               DO jj = 1, khls + 1
+                  ij1 = ipj2 - (khls + 1) + jj                   ! need only the last khls + 1 lines until ipj2
+                  ztabglo(jf)%pt4d(            1:  khls,ij1,jk,jl) = ztabglo(jf)%pt4d(jpiglo-2*khls+1:jpiglo-khls,ij1,jk,jl)
+                  ztabglo(jf)%pt4d(jpiglo-khls+1:jpiglo,ij1,jk,jl) = ztabglo(jf)%pt4d(         khls+1:     2*khls,ij1,jk,jl)
                END DO
             END DO   ;   END DO
@@ -313,7 +314,7 @@
          !
          DO jf = 1, ipf   ;   DO jl = 1, ipl   ;   DO jk = 1, ipk               ! Scatter back to ARRAY_IN
-            DO jj = 1, nn_hls + 1
-               ij1 = jpj  - (nn_hls + 1) + jj   ! last nn_hls + 1 lines until jpj
-               ij2 = ipj2 - (nn_hls + 1) + jj   ! last nn_hls + 1 lines until ipj2
+            DO jj = 1, khls + 1
+               ij1 = jpj  - (khls + 1) + jj   ! last khls + 1 lines until jpj
+               ij2 = ipj2 - (khls + 1) + jj   ! last khls + 1 lines until ipj2
                DO ji= 1, jpi
                   ii2 = mig(ji)
Index: NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/mppini.F90
===================================================================
--- NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/mppini.F90	(revision 14349)
+++ NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/LBC/mppini.F90	(revision 14363)
@@ -121,5 +121,5 @@
       !!                    mpinei    : number of neighboring domains (starting at 0, -1 if no neighbourg)
       !!----------------------------------------------------------------------
-      INTEGER ::   ji, jj, jn, jp
+      INTEGER ::   ji, jj, jn, jp, jh
       INTEGER ::   ii, ij, ii2, ij2
       INTEGER ::   inijmin   ! number of oce subdomains
@@ -128,4 +128,5 @@
       INTEGER ::   ierr, ios
       INTEGER ::   inbi, inbj, iimax, ijmax, icnt1, icnt2
+      INTEGER, DIMENSION(16*n_hlsmax) :: ichanged
       INTEGER, ALLOCATABLE, DIMENSION(:    ) ::   iin, ijn
       INTEGER, ALLOCATABLE, DIMENSION(:,:  ) ::   iimppt, ijpi, ipproc
@@ -441,9 +442,14 @@
          WRITE(inum,'(a)') '  jpnij jpimax jpjmax    jpk jpiglo jpjglo ( local:   narea    jpi    jpj )'
          WRITE(inum,'(6i7,a,3i7,a)') jpnij,jpimax,jpjmax,jpk,jpiglo,jpjglo,' ( local: ',narea,jpi,jpj,' )'
-         WRITE(inum,'(a)') ' narea    ii    ij   jpi   jpj nimpp njmpp mpiwe mpiea mpiso mpino mpisw mpise mpinw mpine'
+         WRITE(inum,*) 
+         WRITE(inum,       *) '------------------------------------'
+         WRITE(inum,'(a,i2)') ' Mapping of the default neighnourgs '
+         WRITE(inum,       *) '------------------------------------'
+         WRITE(inum,*) 
+         WRITE(inum,'(a)') '  rank    ii    ij   jpi   jpj nimpp njmpp mpiwe mpiea mpiso mpino mpisw mpise mpinw mpine'
          DO jp = 1, jpnij
             ii = iin(jp)
             ij = ijn(jp)
-            WRITE(inum,'(15i6)')  jp, ii, ij, ijpi(ii,ij),  ijpj(ii,ij), iimppt(ii,ij), ijmppt(ii,ij), inei(:,ii,ij)
+            WRITE(inum,'(15i6)')  jp-1, ii, ij, ijpi(ii,ij), ijpj(ii,ij), iimppt(ii,ij), ijmppt(ii,ij), inei(:,ii,ij)
          END DO
       END IF
@@ -479,4 +485,8 @@
       ! set default neighbours
       mpinei(:) = impi(:,narea)
+      DO jh = 1, n_hlsmax
+         mpiSnei(jh,:) = impi(:,narea)   ! default definition
+         mpiRnei(jh,:) = impi(:,narea)
+      END DO
       !
       IF(lwp) THEN
@@ -489,5 +499,4 @@
          WRITE(numout,*) '      mpi nei no-we = ', mpinei(jpnw)  , '   mpi nei no-ea = ', mpinei(jpne)
       ENDIF
-      !
       !                          ! Prepare mpp north fold
       !
@@ -501,8 +510,8 @@
             WRITE(numout,*) '   ==>>>   North fold boundary prepared for jpni >1'
          ENDIF
-         IF (llwrtlay) THEN   ! additional prints in layout.dat
+         IF (llwrtlay) THEN      ! additional prints in layout.dat
             WRITE(inum,*)
             WRITE(inum,*)
-            WRITE(inum,*) 'number of subdomains located along the north fold : ', ndim_rank_north
+            WRITE(inum,*) 'Number of subdomains located along the north fold : ', ndim_rank_north
             WRITE(inum,*) 'Rank of the subdomains located along the north fold : ', ndim_rank_north
             DO jp = 1, ndim_rank_north, 5
@@ -521,7 +530,41 @@
       ENDIF
       !
-      CALL mpp_ini_nc        ! Initialize communicator for neighbourhood collective communications
-      !
-      CALL init_ioipsl       ! Prepare NetCDF output file (if necessary)
+      CALL mpp_ini_nc(nn_hls)    ! Initialize communicator for neighbourhood collective communications
+      DO jh = 1, n_hlsmax
+         mpi_nc_com4(jh) = mpi_nc_com4(nn_hls)   ! default definition
+         mpi_nc_com8(jh) = mpi_nc_com8(nn_hls)
+      END DO
+      !
+      CALL init_excl_landpt      ! exclude exchanges which contain only land points
+      !
+      ! Save processor layout changes in ascii file
+      DO jh = 1, n_hlsmax    ! different halo size
+         DO ji = 1, 8
+            ichanged(16*(jh-1)  +ji) = COUNT( mpinei(ji:ji) /= mpiSnei(jh,ji:ji) )
+            ichanged(16*(jh-1)+8+ji) = COUNT( mpinei(ji:ji) /= mpiRnei(jh,ji:ji) )
+         END DO
+      END DO
+      CALL mpp_sum( "mpp_init", ichanged )   ! must be called by all processes
+      IF (llwrtlay) THEN
+         WRITE(inum,*) 
+         WRITE(inum,       *) '----------------------------------------------------------------------'
+         WRITE(inum,'(a,i2)') ' Mapping of the neighnourgs once excluding comm with only land points '
+         WRITE(inum,       *) '----------------------------------------------------------------------'
+         DO jh = 1, n_hlsmax    ! different halo size
+            WRITE(inum,*) 
+            WRITE(inum,'(a,i2)') 'halo size: ', jh
+            WRITE(inum,       *) '---------'
+            WRITE(inum,'(a)') '  rank    ii    ij mpiwe mpiea mpiso mpino mpisw mpise mpinw mpine'
+            WRITE(inum,   '(11i6,a)')  narea-1, iin(narea), ijn(narea),   mpinei(:), ' <- Org'
+            WRITE(inum,'(18x,8i6,a,i1,a)')   mpiSnei(jh,:), ' <- Send ', COUNT( mpinei(:) /= mpiSnei(jh,:) ), ' modif'
+            WRITE(inum,'(18x,8i6,a,i1,a)')   mpiRnei(jh,:), ' <- Recv ', COUNT( mpinei(:) /= mpiRnei(jh,:) ), ' modif'
+            WRITE(inum,*) ' total changes among all mpi tasks:'
+            WRITE(inum,*) '       mpiwe mpiea mpiso mpino mpisw mpise mpinw mpine'
+            WRITE(inum,'(a,8i6)') ' Send: ', ichanged(jh*16-15:jh*16-8)
+            WRITE(inum,'(a,8i6)') ' Recv: ', ichanged(jh*16 -7:jh*16  )
+         END DO
+      END IF
+      !
+      CALL init_ioipsl           ! Prepare NetCDF output file (if necessary)
       !
       IF (llwrtlay) CLOSE(inum)
@@ -878,5 +921,5 @@
          !
          ALLOCATE( lloce(Ni0glo, ijsz) )                                     ! allocate the strip
-         CALL readbot_strip( ijstr, ijsz, lloce )
+         CALL read_mask( 1, ijstr, Ni0glo, ijsz, lloce )
          inboce = COUNT(lloce)                                               ! number of ocean point in the stripe
          DEALLOCATE(lloce)
@@ -948,9 +991,9 @@
             inry = iny - COUNT( (/ iarea == 1, iarea == inbj /) )      ! number of point to read in y-direction
             isty = 1 + COUNT( (/ iarea == 1 /) )                       ! read from the first or the second line?
-            CALL readbot_strip( ijmppt(1,iarea) - 2 + isty, inry, lloce(2:inx-1, isty:inry+isty-1) )   ! read the strip
+            CALL read_mask( 1, ijmppt(1,iarea) - 2 + isty, Ni0glo, inry, lloce(2:inx-1, isty:inry+isty-1) )   ! read the strip
             !
             IF( iarea == 1    ) THEN                                   ! the first line was not read
                IF( l_Jperio ) THEN                                     !   north-south periodocity
-                  CALL readbot_strip( Nj0glo, 1, lloce(2:inx-1, 1) )   !   read the last line -> first line of lloce
+                  CALL read_mask( 1, Nj0glo, Ni0glo, 1, lloce(2:inx-1, 1) )   !   read the last line -> first line of lloce
                ELSE
                   lloce(2:inx-1,  1) = .FALSE.                         !   closed boundary
@@ -959,5 +1002,5 @@
             IF( iarea == inbj ) THEN                                   ! the last line was not read
                IF( l_Jperio ) THEN                                     !   north-south periodocity
-                  CALL readbot_strip( 1, 1, lloce(2:inx-1,iny) )       !      read the first line -> last line of lloce
+                  CALL read_mask( 1, 1, Ni0glo, 1, lloce(2:inx-1,iny) )   !      read the first line -> last line of lloce
                ELSEIF( c_NFtype == 'T' ) THEN                          !   north-pole folding T-pivot, T-point
                   lloce(2,iny) = lloce(2,iny-2)                        !      here we have 1 halo (even if nn_hls>1)
@@ -1004,7 +1047,7 @@
 
 
-   SUBROUTINE readbot_strip( kjstr, kjcnt, ldoce )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE readbot_strip  ***
+   SUBROUTINE read_mask( kistr, kjstr, kicnt, kjcnt, ldoce )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE read_mask  ***
       !!
       !! ** Purpose : Read relevant bathymetric information in order to
@@ -1014,10 +1057,10 @@
       !! ** Method  : read stipe of size (Ni0glo,...)
       !!----------------------------------------------------------------------
-      INTEGER                         , INTENT(in   ) ::   kjstr       ! starting j position of the reading
-      INTEGER                         , INTENT(in   ) ::   kjcnt       ! number of lines to read
-      LOGICAL, DIMENSION(Ni0glo,kjcnt), INTENT(  out) ::   ldoce       ! ldoce(i,j) = .true. if the point (i,j) is ocean
-      !
-      INTEGER                           ::   inumsave                ! local logical unit
-      REAL(wp), DIMENSION(Ni0glo,kjcnt) ::   zbot, zbdy
+      INTEGER                        , INTENT(in   ) ::   kistr, kjstr   ! starting i and j position of the reading
+      INTEGER                        , INTENT(in   ) ::   kicnt, kjcnt   ! number of points to read in i and j directions
+      LOGICAL, DIMENSION(kicnt,kjcnt), INTENT(  out) ::   ldoce          ! ldoce(i,j) = .true. if the point (i,j) is ocean
+      !
+      INTEGER                          ::   inumsave                     ! local logical unit
+      REAL(wp), DIMENSION(kicnt,kjcnt) ::   zbot, zbdy
       !!----------------------------------------------------------------------
       !
@@ -1025,5 +1068,5 @@
       !
       IF( numbot /= -1 ) THEN
-         CALL iom_get( numbot, jpdom_unknown, 'bottom_level', zbot, kstart = (/1,kjstr/), kcount = (/Ni0glo, kjcnt/) )
+         CALL iom_get( numbot, jpdom_unknown, 'bottom_level', zbot, kstart = (/kistr,kjstr/), kcount = (/kicnt, kjcnt/) )
       ELSE
          zbot(:,:) = 1._wp                      ! put a non-null value
@@ -1031,12 +1074,12 @@
       !
       IF( numbdy /= -1 ) THEN                   ! Adjust with bdy_msk if it exists
-         CALL iom_get ( numbdy, jpdom_unknown,     'bdy_msk', zbdy, kstart = (/1,kjstr/), kcount = (/Ni0glo, kjcnt/) )
+         CALL iom_get ( numbdy, jpdom_unknown,     'bdy_msk', zbdy, kstart = (/kistr,kjstr/), kcount = (/kicnt, kjcnt/) )
          zbot(:,:) = zbot(:,:) * zbdy(:,:)
       ENDIF
       !
-      ldoce(:,:) = zbot(:,:) > 0._wp
+      ldoce(:,:) = NINT(zbot(:,:)) > 0
       numout = inumsave
       !
-   END SUBROUTINE readbot_strip
+   END SUBROUTINE read_mask
 
 
@@ -1092,4 +1135,85 @@
       !
    END SUBROUTINE mpp_getnum
+
+
+   SUBROUTINE init_excl_landpt
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE   ***
+      !!
+      !! ** Purpose : exclude exchanges which contain only land points
+      !!
+      !! ** Method  : if a send or receive buffer constains only land point we
+      !!              flag off the corresponding communication
+      !!              Warning: this selection depend on the halo size -> loop on halo size
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER ::   inumsave
+      INTEGER ::   jh
+      INTEGER ::   ipi, ipj
+      INTEGER ::   iiwe, iiea, iist, iisz 
+      INTEGER ::   ijso, ijno, ijst, ijsz 
+      LOGICAL ::   llsave
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   zmsk
+      LOGICAL , DIMENSION(Ni_0,Nj_0,1)      ::   lloce
+      !!----------------------------------------------------------------------
+      !
+      ! read the land-sea mask on the inner domain
+      CALL read_mask( nimpp, njmpp, Ni_0, Nj_0, lloce(:,:,1) )
+      !
+      ! Here we look only at communications excluding the NP folding.
+      ! As lbcnfd not validated if halo size /= nn_hls, we switch if off temporary...
+      llsave = l_IdoNFold
+      l_IdoNFold = .FALSE.
+      !
+      DO jh = 1, n_hlsmax    ! different halo size
+         !
+         ipi = Ni_0 + 2*jh   ! local domain size
+         ipj = Nj_0 + 2*jh
+         !
+         ALLOCATE( zmsk(ipi,ipj) )
+         zmsk(jh+1:jh+Ni_0,jh+1:jh+Nj_0) = REAL(COUNT(lloce, dim = 3), wp)   ! define inner domain -> need REAL to use lbclnk
+         CALL lbc_lnk('mppini', zmsk, 'T', 1._wp, khls = jh)                 ! fill halos
+         !        
+         iiwe = jh   ;   iiea = Ni_0   ! bottom-left corfer - 1 of the sent data
+         ijso = jh   ;   ijno = Nj_0
+         IF( nn_comm == 1 ) THEN 
+            iist =  0   ;   iisz = ipi
+            ijst =  0   ;   ijsz = ipj
+         ELSE
+            iist = jh   ;   iisz = Ni_0
+            ijst = jh   ;   ijsz = Nj_0
+         ENDIF
+IF( nn_comm == 1 ) THEN       ! SM: NOT WORKING FOR NEIGHBOURHOOD COLLECTIVE COMMUNICATIONS, I DON'T KNOW WHY... 
+         ! do not send if we send only land points
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijst+1:ijst+ijsz) )) == 0 )   mpiSnei(jh,jpwe) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijst+1:ijst+ijsz) )) == 0 )   mpiSnei(jh,jpea) = -1
+         IF( NINT(SUM( zmsk(iist+1:iist+iisz,ijso+1:ijso+jh  ) )) == 0 )   mpiSnei(jh,jpso) = -1
+         IF( NINT(SUM( zmsk(iist+1:iist+iisz,ijno+1:ijno+jh  ) )) == 0 )   mpiSnei(jh,jpno) = -1
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijso+1:ijso+jh  ) )) == 0 )   mpiSnei(jh,jpsw) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijso+1:ijso+jh  ) )) == 0 )   mpiSnei(jh,jpse) = -1
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijno+1:ijno+jh  ) )) == 0 )   mpiSnei(jh,jpnw) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijno+1:ijno+jh  ) )) == 0 )   mpiSnei(jh,jpne) = -1
+         !
+         iiwe = iiwe-jh   ;   iiea = iiea+jh   ! bottom-left corfer - 1 of the received data
+         ijso = ijso-jh   ;   ijno = ijno+jh
+         ! do not send if we send only land points
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijst+1:ijst+ijsz) )) == 0 )   mpiRnei(jh,jpwe) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijst+1:ijst+ijsz) )) == 0 )   mpiRnei(jh,jpea) = -1
+         IF( NINT(SUM( zmsk(iist+1:iist+iisz,ijso+1:ijso+jh  ) )) == 0 )   mpiRnei(jh,jpso) = -1
+         IF( NINT(SUM( zmsk(iist+1:iist+iisz,ijno+1:ijno+jh  ) )) == 0 )   mpiRnei(jh,jpno) = -1
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijso+1:ijso+jh  ) )) == 0 )   mpiRnei(jh,jpsw) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijso+1:ijso+jh  ) )) == 0 )   mpiRnei(jh,jpse) = -1
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijno+1:ijno+jh  ) )) == 0 )   mpiRnei(jh,jpnw) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijno+1:ijno+jh  ) )) == 0 )   mpiRnei(jh,jpne) = -1
+ENDIF
+         !
+         DEALLOCATE( zmsk )
+         !
+         CALL mpp_ini_nc(jh)    ! Initialize/Update communicator for neighbourhood collective communications
+         !
+      END DO
+      l_IdoNFold = llsave
+
+   END SUBROUTINE init_excl_landpt
 
 
Index: NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/SBC/sbcblk.F90
===================================================================
--- NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/SBC/sbcblk.F90	(revision 14349)
+++ NEMO/branches/2021/dev_r14312_MPI_Interface/src/OCE/SBC/sbcblk.F90	(revision 14363)
@@ -501,5 +501,6 @@
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj) ::   zssq, zcd_du, zsen, zlat, zevp
-      REAL(wp) :: ztmp
+      REAL(wp) :: ztst
+      LOGICAL  :: llerr
       !!----------------------------------------------------------------------
       !
@@ -512,18 +513,19 @@
          IF(lwp) WRITE(numout,*) ' === AGRIF => Sanity/consistence test on air humidity SKIPPED! :( ==='
 #else
-         ztmp = SUM(tmask(:,:,1)) ! number of ocean points on local proc domain
-         IF( ztmp > 8._wp ) THEN ! test only on proc domains with at least 8 ocean points!
-            ztmp = SUM(sf(jp_humi)%fnow(:,:,1)*tmask(:,:,1))/ztmp ! mean humidity over ocean on proc
+         ztst = SUM(tmask(:,:,1)) ! number of ocean points on local proc domain
+         IF( ztst > 8._wp ) THEN ! test only on proc domains with at least 8 ocean points!
+            ztst = SUM(sf(jp_humi)%fnow(:,:,1)*tmask(:,:,1))/ztst ! mean humidity over ocean on proc
+            llerr = .FALSE.
             SELECT CASE( nhumi )
             CASE( np_humi_sph ) ! specific humidity => expect: 0. <= something < 0.065 [kg/kg] (0.061 is saturation at 45degC !!!)
-               IF(  (ztmp < 0._wp) .OR. (ztmp > 0.065)  ) ztmp = -1._wp
+               IF( (ztst <   0._wp) .OR. (ztst > 0.065_wp) )   llerr = .TRUE.
             CASE( np_humi_dpt ) ! dew-point temperature => expect: 110. <= something < 320. [K]
-               IF( (ztmp < 110._wp).OR.(ztmp > 320._wp) ) ztmp = -1._wp
+               IF( (ztst < 110._wp) .OR. (ztst >  320._wp) )   llerr = .TRUE.
             CASE( np_humi_rlh ) ! relative humidity => expect: 0. <= something < 100. [%]
-               IF(  (ztmp < 0._wp) .OR.(ztmp > 100._wp) ) ztmp = -1._wp
+               IF( (ztst <   0._wp) .OR. (ztst >  100._wp) )   llerr = .TRUE.
             END SELECT
-            IF(ztmp < 0._wp) THEN
-               IF (lwp) WRITE(numout,'("   Mean humidity value found on proc #",i6.6," is: ",f10.5)') narea, ztmp
-               CALL ctl_stop( 'STOP', 'Something is wrong with air humidity!!!', &
+            IF(llerr) THEN
+               WRITE(ctmp1,'("   Error on mean humidity value: ",f10.5)') ztst
+               CALL ctl_stop( 'STOP', ctmp1, 'Something is wrong with air humidity!!!', &
                   &   ' ==> check the unit in your input files'       , &
                   &   ' ==> check consistence of namelist choice: specific? relative? dew-point?', &
